// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Directive.hpp
// -The declarations interface of the Directive class

// TODO DOC: Add exposition for Anon as a learner, to understand why & how
// Directive objects are used in this system.

#pragma once

#include "Human.hpp"
#include "Sequence.hpp"

/** Represents an action-request within robowaifu's model-of-the-world, with the
 * associated Human 'director' & Sequence instruction objects embedded
 * within */
class Directive {
 public:
  Directive() {}
  /** Basic Directive ctor
   * @param human [IN] the Human requesting the action
   * @param sequence [IN] the Sequence instructions being requested
   */
  Directive(Human const& human, Sequence const& sequence);

  // TODO DESIGN: add non-Human 'directors' (robowaifus, systems, etc.) ctor

  /** @return the Directive's Human 'director' */
  auto who() const noexcept -> decltype(Human{});

  /** @return the Directive's Sequence item */
  auto what() const noexcept -> decltype(Sequence{});

 private:
  Human    human;
  Sequence sequence;
};

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
