// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Sequence.cpp
// -The definitions of the Sequence class

#include "Sequence.hpp"

//------------------------------------------------------------------------------
Sequence::Sequence(std::string const& instr_seq,
                   Human const&       owner,
                   Permit const&      permits)
    : instr_seq{instr_seq}, owner{owner}, permits{permits} {
  // automatically include Master by default into all Sequence's Permit's
  this->permits.push_back(Relation::master);

  // TODO DESIGN:
  // automatically include all non-Master owners into all Sequence's Permit's ?
}

//------------------------------------------------------------------------------
auto Sequence::info() const noexcept -> decltype(std::string{}) {
  return instr_seq;
}

//------------------------------------------------------------------------------
auto Sequence::allows() const noexcept -> decltype(Permit{}) {
  return permits;
}

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
