#include <iostream>
#include "rw_gen_utils.hpp"
using std::cout;

int main() {
  cout << "Hello World\n";

  // TEST:
  json js{};
  js.emplace_back("foo : bar");
  cout << js << '\n';

  // examples below via:
  // https://github.com/nlohmann/json

  // clang-format off
  json j2 = {
    {"pi", 3.141},
    {"happy", true},
    {"name", "Niels"},
    {"nothing", nullptr},
    {"answer", {
      {"everything", 42}
    }},
    {"list", {1, 0, 2}},
    {"object", {
      {"currency", "USD"},
      {"value", 42.99}
    }}
  };
  // clang-format on
  cout << j2 << '\n';

  // a way to express the empty array []
  json empty_array_explicit = json::array();
  cout << empty_array_explicit << '\n';

  // ways to express the empty object {}
  json empty_object_implicit = json({});
  json empty_object_explicit = json::object();
  cout << empty_object_implicit << '\n';
  cout << empty_object_explicit << '\n';

  // a way to express an _array_ of key/value pairs [["currency", "USD"],
  // ["value", 42.99]]
  json array_not_object = json::array({{"currency", "USD"}, {"value", 42.99}});
  cout << array_not_object << '\n';
}
