// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: utility.hpp
// -A collection of definitions for general use

#pragma once

#include <vector>

/** Relationships that entities can be in with robowaifu's Master */
enum class Relation {
  /** The robowaifu's Master himself, perfect accountability */ master,
  /** Can't choose family, but you have to love them */ family,
  /** Close, well-known & trusted friend */ close_fren,
  /** Casual friend, not well-trusted */ fren,
  /** Work colleague, not well-trusted */ coworker,
  /** Unknown Human, untrusted */ stranger
};

/** A container of specified Relation's given 'ALLOW' authorization permissions
 * for engagements with robowaifu */
using Permit = std::vector<Relation>;

/** A container of specified Relation's a Human has with robowaifu's Master */
using Groups = std::vector<Relation>;

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
